﻿# -*- coding: utf-8 -*-


import copy


#選択のしぼりこみ　2010.11.16

#ポリゴンメッシュの選択してる要素（頂点、辺、面）を条件により絞込みます
#現在は辺のみ

#動作条件
#選択形状がポリゴンメッシュ
#編集モードに入ってる

#要素（頂点、辺、面）が2個以上選択されている



def edgedou():
  xscene=xshade.scene()
  ashape=xscene.active_shape()

  #辺の場合
  #動作確認
  aelist=[]
  for i in range(ashape.number_of_edges):
    if ashape.edge(i).active==True:
      aelist.append(i)
  if len(aelist)>0:

    #ここに初期設定
    mode=0 #条件
    sel=0 #0で絞込み、1で除外
    gosaon=False #1で誤差を考慮
    gosa=0.00001 #誤差の傾き（1の場合45度）
    renzoku=1

    while(renzoku==1):
      #ダイアログ表示

      diae=xshade.create_dialog()
      idxe1=diae.append_selection('/X軸と並行な辺/Y軸と並行な辺/Z軸と並行な辺/YZ平面（側面図）と並行な辺/XZ平面（上面図）と並行な辺/XY平面（正面図）と並行な辺')
      idxe2=diae.append_selection('/に絞り込む/を選択から除外')
#      idxe3=diae.append_bool('誤差ON')
      idxe4=diae.append_float('誤差(1の場合45度以下）:')

      diae.set_value(idxe1,mode)
      diae.set_value(idxe2,sel)
#      diae.set_value(idxe3,gosaon)
      diae.set_value(idxe4,gosa)

      xshade.idle(10)
      kekkae=diae.ask('選択の絞込み')

      if kekkae==False:renzoku=0

      if kekkae==True:
        mode=diae.get_value(idxe1)
        sel=diae.get_value(idxe2)
#        gosaon=diae.get_value(idxe3)
        gosa=diae.get_value(idxe4)

        tuikalist=[]

#        if gosaon==True:
#          tgosa=gosa
#        else:
#          tgosa=0

        #選択辺を1個1個検査
        for i in aelist:
          v0pos=ashape.vertex(ashape.edge(i).v0).position
          v1pos=ashape.vertex(ashape.edge(i).v1).position

          if mode==0:
            #X軸と並行な辺
            tei=abs(v0pos[0]-v1pos[0])
            if tei!=0:
              if abs(v0pos[1]-v1pos[1])/tei<=gosa and abs(v0pos[2]-v1pos[2])/tei<=gosa:
                tuikalist.append(i)

          if mode==1:
            #Y軸と並行な辺
            tei=abs(v0pos[1]-v1pos[1])
            if tei!=0:
              if abs(v0pos[0]-v1pos[0])/tei<=gosa and abs(v0pos[2]-v1pos[2])/tei<=gosa:
                tuikalist.append(i)

          if mode==2:
            #Z軸と並行な辺
            tei=abs(v0pos[2]-v1pos[2])
            if tei!=0:
              if abs(v0pos[0]-v1pos[0])/tei<=gosa and abs(v0pos[1]-v1pos[1])/tei<=gosa:
                tuikalist.append(i)

          if mode==3:
            #YZ平面と並行な辺
            tei1=abs(v0pos[1]-v1pos[1])
            tei2=abs(v0pos[2]-v1pos[2])
            if tei1!=0:
              if abs(v0pos[0]-v1pos[0])/tei1<=gosa:
                tuikalist.append(i)

            if tei2!=0:
              if abs(v0pos[0]-v1pos[0])/tei2<=gosa:
                tuikalist.append(i)

          if mode==4:
            #XZ平面と並行な辺
            tei1=abs(v0pos[0]-v1pos[0])
            tei2=abs(v0pos[2]-v1pos[2])
            if tei1!=0:
              if abs(v0pos[1]-v1pos[1])/tei1<=gosa:
                tuikalist.append(i)

            if tei2!=0:
              if abs(v0pos[1]-v1pos[1])/tei2<=gosa:
                tuikalist.append(i)

          if mode==5:
            #XY平面と並行な辺
            tei1=abs(v0pos[0]-v1pos[0])
            tei2=abs(v0pos[1]-v1pos[1])
            if tei1!=0:
              if abs(v0pos[2]-v1pos[2])/tei1<=gosa:
                tuikalist.append(i)

            if tei2!=0:
              if abs(v0pos[2]-v1pos[2])/tei2<=gosa:
                tuikalist.append(i)


        #選択辺を絞込み
        if sel==0:
          for i in range(ashape.number_of_edges):
            ashape.edge(i).active=False
          for i in tuikalist:
            ashape.edge(i).active=True

        if sel==1:
          for i in tuikalist:
            ashape.edge(i).active=False

        xscene.exit_modify_mode()
        xscene.enter_modify_mode()

        #結果を確定するか？
        dia4=xshade.create_dialog()
        dia4.append_push_button('処理を確定しますか?')
        xshade.idle(10)

        kekkaf=dia4.ask('選択の絞込み')

        if kekkaf==True:renzoku=0

        else:
          #選択を元に戻す
          for i in range(ashape.number_of_edges):
            ashape.edge(i).active=False
          for i in aelist:
            ashape.edge(i).active=True
          xscene.exit_modify_mode()
          xscene.enter_modify_mode()





xscene=xshade.scene()
ashape=xshade.scene().active_shape()

error=0
dousasuru=0

#動作条件確認その1

if ashape.type==7 and xscene.is_modify_mode==True:

  #辺の場合
  if xscene.selection_mode==1:
    edgedou()

